<?php
// =====================================
// dream_fix.ini初期設定用 ver.1.0
// 最終更新： 2023-11-03
// =====================================

if(filter_input(INPUT_POST, 'ini_data') !== null){ //ダウンロード

    try{
        header('Content-Type: text/plain');
        header('X-Content-Type-Options: nosniff');
        header('Content-Disposition: attachment; filename="dream_fix.ini"');
        header('Connection: close');
        header('Cache-Control: no-cache');
        while (ob_get_level()) { ob_end_clean(); }
        echo filter_input(INPUT_POST, 'ini_data');
        exit;
    } catch ( Exception $ex ) {
        exit('download error');
    }
}

?>
<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width">
<meta name="robots" content="noindex">
<meta name="pintareset" content="nopin">
<title>dream.php ver.5 dream_fix.ini作成</title>
<style>
:root{
    --bg: #FFF;
    --color:#222;
    --ac-bold: hsl(152, 30%, 35%);
    --ac-thin: hsl(120,70%, 90%);
    --thin : #DDD;
    counter-reset: item -1;
}
[hidden]{ display:none; }
html{ font-ajust-size:100%; line-height:1.6; font-family:Mieryo,Sans-serif;background:var(--bg); color: var(--color); }
input,textarea,select,button{ font-size:100%; }
select,button,input[type="checkbox"],label{ cursor:pointer; vertical-align:center; }
input[type="text"]{ font-size:1.1rem; }
button{ padding:.2rem .6rem; font-size:1.1rem; }
body{ max-width:50rem; line-height:1.6; margin:auto; padding:1em 3vw 10vh;}
td{ text-align:center; }
a:link,summary{ cursor:pointer; text-decoration:underline; color:blue; }
h1{ text-align:center; color: var(--ac-bold) }
h2,h3{ border-radius: .3em; padding:.2em .6em; }
h2{ margin:2rem 0; background:var(--ac-thin); color:var(--ac-bold); }
ol[start]{ margin:1em 0; padding:0; }
ol[start]>li{ list-style:none; border:1px solid; padding:10px; margin:1em 0; box-shadow:4px 4px var(--thin); }
ol[start]>li::before {
    content: "項目番号[ " counter(item) " ]";
    display:block; border-bottom:1px dashed; margin-bottom:1em;
    counter-increment: item;
}
ul.names label { display:flex; gap:1em; }
ul.names span{ min-width:8em; }
ul.names>li{ margin:.4em 0; }
li.del { animation: fadeOut 2s forwards; }
dl{ border:1px solid; }
dt{ padding:.2em .5em; background:var(--thin); font-weight:bolder; }
dd{ margin:0 0 0 2em; padding:.5em; }
div.option:not(:last-of-type){ margin-bottom:1rem; }
div.option label{ display:block; }
div.option select{ width:100%; }
p.submit{ text-align:center; }
samp{ background:var(--thin); }
div.del{ text-align:right; margin-top:1rem; }
button.del-btn{ font-size:.9rem }
.note{ border:3px double; margin:3rem 0; padding:.2em 2vw; }
textarea[name="ini_data"]{ margin-top:1em; width:100%; }
@media (max-width: calc(28em + 10vw)){
    ul.names{ list-style:none; padding:0; }
    ul.names label { flex-direction:column; gap: 0; }
    ul.names span{ font-size:.9rem; }
}
@keyframes fadeOut {
    0% { opacity: 1; }
    100% { opacity: 0; }
}
</style>
<body>

<?php
if(count($_POST) > 0)
{
    //POSTデータ
    $cookie_url = filter_input(INPUT_POST, 'path', FILTER_VALIDATE_URL);
    $set_label = filter_input(INPUT_POST, 'set_label', FILTER_SANITIZE_FULL_SPECIAL_CHARS, FILTER_REQUIRE_ARRAY);
    $set_name = filter_input(INPUT_POST, 'set_name', FILTER_SANITIZE_FULL_SPECIAL_CHARS, FILTER_REQUIRE_ARRAY);
    $set_type = filter_input(INPUT_POST, 'set_type', FILTER_DEFAULT, FILTER_REQUIRE_ARRAY);
    $set_select = filter_input(INPUT_POST, 'set_select', FILTER_SANITIZE_FULL_SPECIAL_CHARS, FILTER_REQUIRE_ARRAY);
    $ini_option = filter_input(INPUT_POST, 'option', FILTER_DEFAULT, FILTER_REQUIRE_ARRAY);

    //ラベル
    $list = '';
    foreach($set_label as $i => $v){ 
        $v = (trim($v)==='') ? '項目'.$i : $v;
        $list .= ($set_type[$i] === 'f') ? "$i = \"f_$v\"\n" : "$i = \"$v\"\n"; 
    }
    
    //デフォルト名
    $defName = '';
    foreach($set_name as $i => $v){ 
        $v = (trim($v)==='') ? '名前'.$i : $v;
        $defName  .= "$i = \"$v\"\n"; 
    }

    //選択肢
    $changeSelect = '';
    foreach($set_select as $i => $v){
        if($set_type[$i] === 's' && trim($v)!== ''){
            $changeSelect .= "$i = \"".str_replace("\n", ",", str_replace(["\r\n","\r"],"\n",trim($v)))."\"\n";
        }
    }

    //オプションデフォ値
    $option_def = [
        'form_option' => 0,
        'form_type' => 0,
        'form_first' => 2, 
        'form_focus' => 1,
        'set_value' => '情報を登録',
        'del_value' => '情報を削除',
        'convert_on' => 0
    ];
    $fix_option = array_merge($option_def, $ini_option);


    //データを変数に置き換え
    list(
        'form_output' => $form_output,
        'form_type' => $form_type,
        'form_first' => $form_first, 
        'form_focus' => $form_focus,
        'set_value' => $set_value,
        'del_value' => $del_value,
        'convert_on' => $convert_on ) = $fix_option;

    $set_value = htmlspecialchars($set_value);
    $del_value = htmlspecialchars($del_value);

    //内容
    $dream_ini_set = <<<INI
;=============================================
;[cookie]
    
;ドメイン直下以外で運営している場合はサイトのURLをhttpから
site_url = "$cookie_url"
        
;=============================================
[list]
;変換項目
;項目番号 = "項目名"

$list

[defName]
;デフォルト値
;項目番号 = "デフォルト名"
;項目番号 = "デフォルト名,モード名==デフォルト名"

$defName

[changeSelect]
;選択式にしたい項目番号と選択項目
;項目番号 = "項目1,項目2,項目3,項目4"

$changeSelect

;=============================================
[option]

;html出力かxhtml出力か
;0:HTML, 1:XHTML
form_output = $form_output

;入力フォームタイプ
;0:ulリスト, 1:table
form_type = $form_type

;入力フォーム初期値
;0:項目名, 1:「未登録」, 2:空(未記入), 3:デフォルト値
form_first = $form_first

;入力フォームがフォーカス状態時の挙動（JavaScript）
;0:変わらない, 1:内容を選択状態, 2:内容が消える
form_focus = $form_focus

;登録・削除・実行フォーム
;0:select, 1:radia, 2:button
form_submit = 2
form_value = "$set_value,$del_value,実行"

;DreamMaker2での保存を利用する
;0:使わない, 1:使う
convert_on = $convert_on

;cookieを利用できない場合はpostを使う
;0:使わない, 1:作品ぺージにフォーム出力記述, 2:作品以外のページにフォーム否出力記述
post_on = 0

INI;

    //dream_fix.ini作成
    try {
        file_put_contents('dream_fix.ini', $dream_ini_set, LOCK_EX);

        echo '<p class="check"><strong>dream_fix.iniの作成に成功しました。</strong>';

    } catch ( Exception $ex ) {
        echo '<p class="check"><strong>dream_fix.iniの作成に失敗しました。</strong>';
        echo '<p>お手数ですが、以下のボタンから dream_fix.ini を保存するか、テキストエリアの内容をテキストエディタにコピペして「dream_fix.ini」という名称で保存して、 [<b>dream</b>] フォルダにアップロードしてください。';
        echo '<p>拡張子の影響で[デバイスに損害を与える可能性がある] [危害を加える可能性がある]とダウンロードが止まる場合がありますが、保存しても大丈夫です。不安な方はテキストエリアからコピペしてください。';
        echo '<form method="post" style="text-align:center">';
        echo '<button type="submit" name="download">dream_fix.iniをダウンロードする</button>';
        echo '<br><textarea name="ini_data" rows="10">'.$dream_ini_set.'</textarea>';
        echo '</form>';
    }

    //htaccess作成
    if(!is_file(__DIR__.'/.htaccess') && filter_input(INPUT_POST, 'htaccess') === '1')
    {
        $htaccess  = "Options -Indexes\n";
        $htaccess .= '<FilesMatch "^\.ht|\.(txt|ini)$">'."\n";
        $htaccess .= "Require all denied\n";
        $htaccess .= "</FilesMatch>\n";
        
        try {
            file_put_contents('.htaccess', $htaccess, LOCK_EX);
            echo '<p class="check"><strong>.htaccessの作成に成功しました。</strong>';
        } catch ( Exception $ex ) {
            echo '<p class="check"><strong>.htaccessの作成に失敗しました。</strong><br>';
            echo 'お手数ですが、FTPやファイルマネージャーで[<b>dream</b>]フォルダ内の「recommend-htaccess.txt」を「.htaccess」という名称に書き換えてください。.htaccessがなくてもdream.phpは動きます。';
        }
    }
    die();
} else {
    if(is_file(__DIR__.'/dream_fix.ini')) die('<p class="ok"><strong>設定完了済みです。</strong>');
}
?>

<h1>dream_fix.ini作成</h1>

<?php
if(!extension_loaded('mbstring')) {
	echo "<ul class='checked'><li><strong>mbstring拡張モジュールが無効状態</strong>です。<br>ふりがな登録機能やカスタム表示機能を使いたい場合は、mbstring拡張モジュールのインストールと有効化が必要です。ふりがな登録機能やカスタム表示機能を利用しないのであればdream.phpを使えます。</li></ul>";
}
?>

<form method="post" id="setting_ini">

<h2>登録名情報</h2>
<p>設定順に、0からの連番の<b class="key">項目番号</b>が割り振られます。この番号は出力時のキーとして使われます。登録名情報と対応する項目番号を覚えておいてください。
<details>
    <summary>入力内容詳細</summary>
    <dl>
        <dt>項目名<dd>登録フォーム出力時のラベルになります。何を入力（選択）するかわかりやすい文言を。空欄の場合は「項目 + <var>項目番号</var>」（例; 項目0）になります。
        <dt>デフォルト名<dd>空欄の場合は「名前 + <var>項目番号</var>」（例; 名前0）になります。デフォルト名はページごとに出力内容を変えられます。
        <dt>フォームタイプ<dd><b>通常入力</b>は一般的な入力フォーム / <b>フリガナ入力</b>はひらがなカタカナのみを受け入れる入力フォーム（mbstringモジュールが有効でないと選択不可） / <b>選択式</b>は<code>&lt;select&gt;</code>
        <dt>選択肢<dd>フォームタイプを[選択式]にしたときは、選択肢を改行区切で羅列してください。選択肢の一つにデフォルト名に設定した語句を含めてください。
    </dl>
</details>
<noscript><p>項目の増減にはJavaScriptが有効な環境が必要です。JavaScriptが有効な環境でアクセスするか、「<a href="https://a-c.2-d.jp/index/dream/?page=setup">導入手順 &gt; 初期設定 : dream_fix.iniを編集</a>」を参照してdream_fix.iniを作成してください。</noscript>
<ol start="0" id="namelist">
    <?php
        $disabled = (extension_loaded('mbstring')) ? '' : ' disabled';
        $nm = array(
            'あなたの苗字,鈴木', 'あなたの名前,花子',
        );
        foreach($nm as $i => $v){
            list($n,$d) = explode(',', $v);
            echo <<<HTM
        <li>
            <ul class="names">
                <li class="names-item"><label><span>項目名</span><input type="text" name="set_label[]" value="" placeholder="$n"></label>
                <li class="names-def"><label><span>デフォルト名</span><input type="text" value="" name="set_name[]" placeholder="$d"></label>
                <li class="names-type"><label><span>フォームタイプ</span><select name="set_type[]">
                    <option value="">通常入力
                    <option value="f"$disabled>フリガナ入力
                    <option value="s">選択式
                </select></label>
                <li class="names-select"><label><span>選択肢</span><textarea rows="3" cols="30" placeholder="選択肢" name="set_select[]"></textarea></label>
            </ul>
HTM; 

        }
    ?>

</ol>

<h2>登録フォーム設定</h2>

<div class="option">
<label>登録フォーム出力コード（登録フォームを表示したいページにあわせてください）</label>
<select name="option[form_output]">
    <option value="0" selected>HTMLに準拠する
    <option value="1">XHTMLに準拠する
</select>
<details>
    <summary>判別方法</summary>
    登録フォームを表示したいページが以下に当てはまるならXHTMLで、そうでないならHTML
    <ul>
        <li>ページ（ファイル）のソースコードの冒頭が<code>&lt;?xml</code>で始まっている
        <li>DOCTYPE宣言がXHTML（例; <code>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD <mark>XHTML</mark> ...</code>）
        <li><code>&lt;html&gt;</code>タグにxmlns属性がついている（例; <code>&lt;html <mark>xmlns="http://www.w3.org/1999/xhtml"</mark>&gt;</code>）
    </ul>
</details>

</div>

<div class="option">
<label>入力フォームタイプ</label>
<select name="option[form_type]">
    <option value="0" selected>&lt;ul&gt;でコーディング
    <option value="1">&lt;table&gt;でコーディング
</select>
</div>


<div class="option">
<label>入力初期値</label>
<select name="option[form_first]">
    <option value="0">項目名
    <option value="1">「未登録」
    <option value="2">空（未記入）
    <option value="3" selected>デフォルト名
</select>
</div>

<div class="option">
<label>入力フォームがフォーカス状態時の挙動（JavaScript）</label>
<select name="option[form_focus]">
    <option value="0">変化無し
    <option value="1" selected>内容を選択状態にする
    <option vallue="2">内容を一時的に消す
</select>

<details>
	<summary>サンプル</summary>
		<ul>
			<li><label>変化なし：<input type="text" value="登録名"></label>
			<li><label>選択状態：<input type="text" value="登録名" onfocus="this.select()" onblur=""></label>
			<li><label>消す：<input type="text" value="登録名" onfocus="if(this.value=='登録名'){this.value='';}" onblur="if(this.value==''){this.value='登録名';}"></label>
		</ul>
</details>

</div>

<!--
<div class="option">
<label>登録・削除・実行</label>
<select name="option['form_focus']">
    <option value="0">select
    <option value="1">radio
    <option vallue="2" selected>button
</select>
</div>
-->

<div class="option">
<label>登録ボタン文言</label>
<input type="text" name="option[set_value]" value="情報を登録">
</div>

<div class="option">
    <label>削除ボタン文言</label>
    <input type="text" name="option[del_value]" value="情報を削除">

</div>

<div class="option">
<label>DreamMaker2での登録情報を利用する</label>
<select name="option[convert_on]">
    <option value="0" selected>DreamMaker2での登録は使わない
    <option value="1">DreamMaker2での登録を使う
</select>
<small>登録項目が同数のときのみコンバートされます</small>
</div>


<h2>登録名Cookie有効範囲</h2>

<p><samp>https://siteurl.com/site1/</samp> と <samp>https://siteurl.com/site2/</samp>で別々のサイトを運営していてそれぞれで別の設定のdream.phpを使う場合など、同ドメインの中の特定のフォルダ内でだけCookieを有効にしたい場合は有効範囲のトップアドレス（例; <samp>https://siteurl.com/site1/</samp>）を入力してください。特に何もなければ空欄でいいです。


<p><label for="form-url">URL</label> <input type="url" name="path" value="" placeholder="<?php echo (empty($_SERVER['HTTPS']) ? 'http://' : 'https://') . $_SERVER['HTTP_HOST']; ?>/***/" pattern="(http|https)://.*" id="form-url">


<?php if(!is_file(__DIR__.'/.htaccess')){ ?>
    
<h2>セキュリティ</h2>
    <p><label><input type="checkbox" value="1" name="htaccess" checked>
    .htaccessで設定ファイルに直接アクセスできないようにする</label>

<?php } ?>


<div class="note">
    <p>dream_fix.iniの保存が成功した場合、setup.php（現在のページ）にはアクセスできなくなります。
    <p>設定を変更したい場合は、オンライン上のdream_fix.iniをダウンロードして編集するか、オンライン上のdream_fix.iniを削除のうえ改めてsetup.php（現在のページ）にアクセスして設定（作成）し直してください。
    <p>オンライン上での設定変更はdream.phpのバージョンアップをお待ちください。
</div>


<p class="submit">
    <button type="submit" id="edit">入力した情報で設定を保存する</button>
</form>

<script>

    //送信確認（一応）
    document.getElementById('setting_ini').addEventListener('submit', e=>{
        if (!window.confirm('ここまでの情報で設定ファイルを作成しますか？')) {
            e.preventDefault();
        }
    });

    //選択肢入力フォーム表示非表示
    Array.from(document.querySelectorAll('.names-select'), a =>{ a.hidden=true; });
    document.addEventListener('change', (e) => {
        if(e.target.name==='set_type[]')
        {
            const index = e.target.selectedIndex,
            s = e.target.closest('.names-type').nextElementSibling;
            if(e.target[index].value==='s'){
                s.hidden = false;
            } else {
                s.hidden = true;
            }
        }
    });

    //設定項目追加削除
    const nmbl = document.getElementById('namelist'),
    list = document.querySelector('#namelist>li:first-child'),
    nmbtn = '<button type="button" id="put">設定項目を増やす</button>',
    delbtn = '<div class="del"><button type="button" class="del-btn">この項目を削除</button></div>';

    nmbl.insertAdjacentHTML('afterend', nmbtn);
    Array.from(nmbl.querySelectorAll('#namelist>li'), a => a.insertAdjacentHTML('beforeend',delbtn ));
    
    document.addEventListener('click', (e) => {
        if (e.target.id === "put"){ //追加
            const list_clone = list.cloneNode(true);
            Array.from(list_clone.querySelectorAll('input,textarea'), a => a.value='');
            list_clone.querySelector('.names-select').hidden = true;
            nmbl.appendChild(list_clone);
        }

        if(e.target.className === 'del-btn'){ //削除

            const li = e.target.closest('li');
	        li.classList.add("del");
	        setTimeout(() => {
	            li.classList.remove("del");
                li.remove();
	        }, 1000);

        }
    });

</script>